# Class OjInputDateTimeBase

This is the base class for oj-input-date-time WebElement, and is generated from the component's metadata. Do not modify these contents since they'll be replaced during the next generation. Put overrides into the WebElements's subclass, OjInputDateTime.ts.

#### Hierarchy

- OjWebElement
  - OjInputDateTimeBase
    - OjInputDateTime

#####
Index

### Constructors

constructor

### Methods

changeMessagesCustom
changeValue
clear
click
findElement
findElements
getAsyncValidators
getAttribute
getAutocomplete
getAutofocus
getConverter
getCssValue
getDatePicker
getDayFormatter
getDayMetaData
getDescribedBy
getDisabled
getDisplayOptions
getHelp
getHelpHints
getKeyboardEdit
getLabelEdge
getLabelHint
getLabelledBy
getLocation
getMax
getMessagesCustom
getMin
getName
getPickerAttributes
getPlaceholder
getProperty
getRawValue
getReadonly
getReadonlyUserAssistanceShown
getRect
getRenderMode
getRequired
getSize
getText
getTimePicker
getTranslations
getUserAssistanceDensity
getValid
getValidators
getValue
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady

## Constructors

### constructor

- new OjInputDateTimeBase(el, locators): OjInputDateTimeBase

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjInputDateTimeBase

  Inherited from OjWebElement.constructor

## Methods

### changeMessagesCustom

- changeMessagesCustom(messagesCustom): Promise<void>

- Sets the value of `messagesCustom` property. A list of messages added by an application to the component. See the Help documentation for more information.

  #### Parameters

  - ##### messagesCustom: object[]

    The value to set for `messagesCustom`

  #### Returns Promise<void>

### changeValue

- changeValue(value): Promise<void>

- Sets the value of `value` property. The value of the input datetime element, which must be an ISOString. See the Help documentation for more information.

  #### Parameters

  - ##### value: string

    The value to set for `value`

  #### Returns Promise<void>

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.click

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from OjWebElement.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from OjWebElement.findElements

### getAsyncValidators

- getAsyncValidators(): Promise<object[]>

- Gets the value of `asyncValidators` property. Specifies a list of asynchronous validators used by the component when performing validation. Use async-validators when you need to perform some validation work on the server. See the Help documentation for more information.

  #### Returns Promise<object[]>

  The value of `asyncValidators` property.

  #### Deprecated

  Since 8.0.0. Use the validators property instead for either regular Validators or AsyncValidators.

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getAttribute

### getAutocomplete

- getAutocomplete(): Promise<string>

- Gets the value of `autocomplete` property. Specifies a component's autocomplete state. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `autocomplete` property.

  #### Deprecated

  Since 17.0.0. The date field contains mask segments instead of a general input, so autocomplete is not supported.

### getAutofocus

- getAutofocus(): Promise<boolean>

- Gets the value of `autofocus` property. Specifies whether the component will get input focus when the page is loaded. See the Help documentation for more information.

  #### Returns Promise<boolean>

  The value of `autofocus` property.

  #### Deprecated

  Since 17.0.0. This is not recommended for accessibility reasons.

### getConverter

- getConverter(): Promise<object>

- Gets the value of `converter` property. An object that converts the datetime value. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `converter` property.

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getCssValue

### getDatePicker

- getDatePicker(): Promise<DatePicker>

- Gets the value of `datePicker` property. An object whose properties describe the appearance and behavior of the date picker. See the Help documentation for more information.

  #### Returns Promise<DatePicker>

  The value of `datePicker` property.

### getDayFormatter

- getDayFormatter(): Promise<null>

- Gets the value of `dayFormatter` property. Specifies a callback function used when rendering the day. See the Help documentation for more information.

  #### Returns Promise<null>

  The value of `dayFormatter` property.

### getDayMetaData

- getDayMetaData(): Promise<object>

- Gets the value of `dayMetaData` property. Specifies additional information to be used when rendering the day. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `dayMetaData` property.

  #### Deprecated

  Since 17.0.0. Use dayFormatter instead, as it is more flexible.

### getDescribedBy

- getDescribedBy(): Promise<string>

- Gets the value of `describedBy` property. The form component's oj-label automatically sets described-by to make it accessible. It is not meant to be set by application developer.

  #### Returns Promise<string>

  The value of `describedBy` property.

### getDisabled

- getDisabled(): Promise<boolean>

- Gets the value of `disabled` property. Specifies whether the component is disabled. The default is false.

  #### Returns Promise<boolean>

  The value of `disabled` property.

### getDisplayOptions

- getDisplayOptions(): Promise<DisplayOptions>

- Gets the value of `displayOptions` property. Display options for auxiliary content that determines whether or not it should be displayed.

  #### Returns Promise<DisplayOptions>

  The value of `displayOptions` property.

### getHelp

- getHelp(): Promise<Help>

- Gets the value of `help` property. Form component help information.

  #### Returns Promise<Help>

  The value of `help` property.

### getHelpHints

- getHelpHints(): Promise<HelpHints>

- Gets the value of `helpHints` property. Represents hints for an oj-form-layout element to render help information on the label of the editable component.

  #### Returns Promise<HelpHints>

  The value of `helpHints` property.

### getKeyboardEdit

- getKeyboardEdit(): Promise<string>

- Gets the value of `keyboardEdit` property. Determines if keyboard entry of the text is allowed. When disabled, the picker must be used to select the date. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `keyboardEdit` property.

  #### Deprecated

  Since 17.0.0. This is not supported in the Redwood UX specification.

### getLabelEdge

- getLabelEdge(): Promise<string>

- Gets the value of `labelEdge` property. Defines how the label of a component is created. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `labelEdge` property.

### getLabelHint

- getLabelHint(): Promise<string>

- Gets the value of `labelHint` property. Represents a hint for oj-form-layout element to render a label on the editable component.

  #### Returns Promise<string>

  The value of `labelHint` property.

### getLabelledBy

- getLabelledBy(): Promise<null | string>

- Gets the value of `labelledBy` property. The oj-label sets the labelledBy property programmatically on the form component. See the Help documentation for more information.

  #### Returns Promise<null | string>

  The value of `labelledBy` property.

  #### Deprecated

  Since 17.0.0. This is an internal API and is not supported in the Redwood UX specification.

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from OjWebElement.getLocation

### getMax

- getMax(): Promise<null | string>

- Gets the value of `max` property. The maximum selectable datetime, in ISO string format. When set to null, there is no maximum.

  #### Returns Promise<null | string>

  The value of `max` property.

### getMessagesCustom

- getMessagesCustom(): Promise<object[]>

- Gets the value of `messagesCustom` property. A list of messages added by an application to the component. See the Help documentation for more information.

  #### Returns Promise<object[]>

  The value of `messagesCustom` property.

### getMin

- getMin(): Promise<null | string>

- Gets the value of `min` property. The minimum selectable datetime, in ISO string format. When set to null, there is no minimum.

  #### Returns Promise<null | string>

  The value of `min` property.

### getName

- getName(): Promise<string>

- Gets the value of `name` property. Specifies the name of the component.

  #### Returns Promise<string>

  The value of `name` property.

  #### Deprecated

  Since 6.0.0. JET does not use form submit, so this is not needed.

### getPickerAttributes

- getPickerAttributes(): Promise<PickerAttributes>

- Gets the value of `pickerAttributes` property. Specifies attributes to be set on the picker DOM element when it is launched. See the Help documentation for more information.

  #### Returns Promise<PickerAttributes>

  The value of `pickerAttributes` property.

  #### Deprecated

  Since 17.0.0. Changing the Class or Style property is not recommended, as it leads to an inconsistent UI.

### getPlaceholder

- getPlaceholder(): Promise<string>

- Gets the value of `placeholder` property. The placeholder text to set on the element.

  #### Returns Promise<string>

  The value of `placeholder` property.

  #### Deprecated

  Since 17.0.0. The date field contains mask segments instead of a general input, so placeholder is not supported.

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjWebElement.getProperty

### getRawValue

- getRawValue(): Promise<string>

- Gets the value of `rawValue` property. Read-only property used for retrieving the current value from the input field in string form. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `rawValue` property.

### getReadonly

- getReadonly(): Promise<boolean>

- Gets the value of `readonly` property. Specifies whether the component is read-only. A read-only element cannot be modified, but user interaction is allowed. See the Help documentation for more information.

  #### Returns Promise<boolean>

  The value of `readonly` property.

### getReadonlyUserAssistanceShown

- getReadonlyUserAssistanceShown(): Promise<string>

- Gets the value of `readonlyUserAssistanceShown` property. Specifies which user assistance types should be shown when the component is readonly.

  #### Returns Promise<string>

  The value of `readonlyUserAssistanceShown` property.

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from OjWebElement.getRect

### getRenderMode

- getRenderMode(): Promise<string>

- Gets the value of `renderMode` property. Specifies whether to render the date picker in JET, or as a native picker control. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `renderMode` property.

  #### Deprecated

  Since 8.0.0. Support for "native" mode rendering is deprecated because JET promotes a consistent Oracle UX based upon the Redwood design system. As a result, the theme variable "$inputDateTimeRenderModeOptionDefault" is also deprecated.

### getRequired

- getRequired(): Promise<boolean>

- Gets the value of `required` property. Specifies whether the component is required or optional. See the Help documentation for more information.

  #### Returns Promise<boolean>

  The value of `required` property.

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from OjWebElement.getSize

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getText

### getTimePicker

- getTimePicker(): Promise<TimePicker>

- Gets the value of `timePicker` property. An object whose properties describe the appearance and behavior of the time picker. See the Help documentation for more information.

  #### Returns Promise<TimePicker>

  The value of `timePicker` property.

### getTranslations

- getTranslations(): Promise<null | Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<null | Translations>

  The value of `translations` property.

### getUserAssistanceDensity

- getUserAssistanceDensity(): Promise<string>

- Gets the value of `userAssistanceDensity` property. Specifies the density of the form component's user assistance presentation.

  #### Returns Promise<string>

  The value of `userAssistanceDensity` property.

### getValid

- getValid(): Promise<string>

- Gets the value of `valid` property. The validity state of the component

  #### Returns Promise<string>

  The value of `valid` property.

### getValidators

- getValidators(): Promise<object[]>

- Gets the value of `validators` property. A list of validators used by the element, along with any implicit component validators, when performing validation. See the Help documentation for more information.

  #### Returns Promise<object[]>

  The value of `validators` property.

### getValue

- getValue(): Promise<string>

- Gets the value of `value` property. The value of the input datetime element, which must be an ISOString. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `value` property.

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from OjWebElement.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from OjWebElement.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.sendKeys

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjWebElement.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjWebElement.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjWebElement.whenReady

Generated using TypeDoc